//package com.xs.core.common.aspect;
//
//import com.alibaba.fastjson2.JSON;
//import com.alibaba.fastjson2.JSONWriter;
//import com.xs.core.common.content.UserContext;
//import com.xs.core.common.content.UserContextHolder;
//import com.xs.core.model.log.entity.ApiRequestLog;
//import com.xs.core.service.log.IApiRequestLogService;
//import jakarta.servlet.http.HttpServletRequest;
//import lombok.extern.slf4j.Slf4j;
//import org.apache.commons.lang3.exception.ExceptionUtils;
//import org.aspectj.lang.ProceedingJoinPoint;
//import org.aspectj.lang.annotation.Around;
//import org.aspectj.lang.annotation.Aspect;
//import org.aspectj.lang.reflect.MethodSignature;
//import org.springframework.beans.factory.annotation.Autowired;
//import org.springframework.http.HttpStatus;
//import org.springframework.stereotype.Component;
//
//import java.time.LocalDateTime;
//import java.util.HashMap;
//import java.util.Map;
//import java.util.concurrent.CompletableFuture;
//
////@Aspect
////@Component
//@Slf4j
//public class ApiLogAspect {
////    @Autowired
////    private IApiRequestLogService logService;
////
////    @Autowired
////    private HttpServletRequest request;
//
////    @Around("execution(* com.xs.core.controller..*.*(..))")
//    public Object logApiRequest(ProceedingJoinPoint joinPoint) throws Throwable {
//        long startTime = System.currentTimeMillis();
//
//
//        ApiRequestLog log1 = new ApiRequestLog();
//        log1.setRequestTime(LocalDateTime.now());
//        log1.setRequestMethod(request.getMethod());
//        log1.setRequestUrl(request.getRequestURI());
//        log1.setIpAddress(request.getRemoteAddr());
//        log1.setUserAgent(request.getHeader("User-Agent"));
//        UserContext context = UserContextHolder.getContext();
//        if (context != null) {
//            log1.setUserId(context.getId());
//        }
//        // 获取方法参数
//        Object[] args = joinPoint.getArgs();
//        MethodSignature signature = (MethodSignature) joinPoint.getSignature();
//        String[] parameterNames = signature.getParameterNames();
//
//        // 记录请求参数
//        Map<String, Object> requestParams = new HashMap<>();
//        for (int i = 0; i < args.length; i++) {
//            requestParams.put(parameterNames[i], args[i]);
//        }
//        log1.setRequestParams(objectToJson(requestParams));
//
//        Object result = null;
//        try {
//            result = joinPoint.proceed();
//            log1.setResponseStatus(HttpStatus.OK.value());
//            log1.setResponseBody(objectToJson(result));
//        } catch (Exception e) {
//            log1.setResponseStatus(HttpStatus.INTERNAL_SERVER_ERROR.value());
//            log1.setErrorMessage(ExceptionUtils.getStackTrace(e));
//            log1.setResponseBody(objectToJson(e));
//            result = e;  // 将异常赋值给 result，以便后续可能的处理
//        } finally {
//            log1.setExecutionTime(System.currentTimeMillis() - startTime);
//            //异步保存日志
//            CompletableFuture.runAsync(() -> {
//                logService.save(log1);
//            });
//        }
//        // 如果发生了异常，在这里重新抛出
//        if (result instanceof Throwable) {
//            throw (Throwable) result;
//        }
//        return result;
//    }
//
//    private String objectToJson(Object obj) {
//        try {
//            return JSON.toJSONString(obj, JSONWriter.Feature.WriteMapNullValue);
//        } catch (Exception e) {
//            log.error("Error converting object to JSON", e);
//            return null;
//        }
//    }
//}
