package com.xs.core.controller.team;

import com.xs.core.model.ResponseResult;
import com.xs.core.service.user.IUserService;
import io.swagger.v3.oas.annotations.Operation;
import io.swagger.v3.oas.annotations.tags.Tag;
import lombok.AllArgsConstructor;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

@RestController
@RequestMapping("/distribution")
@Tag(name = "团队邀请模块", description = "团队邀请模块")
@AllArgsConstructor
public class DistributionController {
    private final IUserService userService;

    @PostMapping("/getShareCode")
    @Operation(summary = "获取邀请码", description = "获取邀请码")
    public ResponseResult<?> getShareCode() {
        String inviteCode = userService.getInviteCode();
        return ResponseResult.success(inviteCode);
    }
}
