package com.xs.core.controller.wallet;

import com.xs.core.common.content.UserContext;
import com.xs.core.common.content.UserContextHolder;
import com.xs.core.model.ResponseResult;
import com.xs.core.model.wallet.resp.WalletInfoResp;
import com.xs.core.service.wallet.WalletService;
import io.swagger.v3.oas.annotations.Operation;
import io.swagger.v3.oas.annotations.tags.Tag;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

@RestController
@RequestMapping("/wallet")
@Tag(name = "钱包", description = "钱包")
public class WalletController {

    @Autowired
    private WalletService walletService;

    @Operation(summary = "获取钱包信息", description = "获取钱包信息")
    @PostMapping("/getWalletInfo")
    public ResponseResult<WalletInfoResp> getWalletInfo() {
        WalletInfoResp walletInfo = walletService.getWalletInfo();
        return ResponseResult.success(walletInfo);
    }
}
