package com.xs.core.init;

import com.xs.core.common.validation.CheckUtils;
import com.xs.core.model.ResponseResult;
import lombok.AllArgsConstructor;
import lombok.extern.slf4j.Slf4j;
import org.springframework.boot.CommandLineRunner;
import org.springframework.context.MessageSource;
import org.springframework.stereotype.Component;

import javax.sql.DataSource;
import java.sql.Connection;

@Component
@AllArgsConstructor
@Slf4j
public class DatabaseInitializer implements CommandLineRunner {
    private final DataSource dataSource;
    private final MessageSource messageSource;

    @Override
    public void run(String... args) throws Exception {
        ResponseResult.setMessageSource(messageSource);
        CheckUtils.setMessageSource(messageSource);
        log.info("MessageSource initialized successfully.");
        try (Connection connection = dataSource.getConnection()) {
            // 执行一个简单的查询来初始化连接
            connection.createStatement().execute("SELECT 1 from dual");
            log.info("Database connection initialized successfully.");
        }
    }
}
