package com.xs.core.model.team.entity;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import com.baomidou.mybatisplus.extension.activerecord.Model;
import java.io.Serializable;
import java.time.LocalDateTime;
import lombok.Getter;
import lombok.Setter;

/**
 * <p>
 * 团队邀请配置
 * </p>
 *
 * @author xudm
 * @since 2024-12-21
 */
@Getter
@Setter
@TableName("b_team_invite_config")
public class TeamInviteConfig extends Model<TeamInviteConfig> {

    /**
     * 主键
     */
    @TableId(value = "id", type = IdType.ASSIGN_ID)
    private Long id;

    /**
     * A队抽成比例 百分比 0.01
     */
    @TableField("team_a_scale")
    private String teamAScale;

    /**
     * B队抽成比例 百分比 0.01
     */
    @TableField("team_b_scale")
    private String teamBScale;

    /**
     * 邀请一人金币奖励
     */
    @TableField("Invite_one_reward")
    private Integer inviteOneReward;

    /**
     * 创建时间
     */
    @TableField("create_time")
    private LocalDateTime createTime;

    /**
     * 修改时间
     */
    @TableField("update_time")
    private LocalDateTime updateTime;

    @Override
    public Serializable pkVal() {
        return this.id;
    }
}
