package com.xs.core.model.team.entity;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import com.baomidou.mybatisplus.extension.activerecord.Model;

import java.io.Serializable;
import java.math.BigDecimal;
import java.time.LocalDateTime;

import lombok.Getter;
import lombok.Setter;

/**
 * <p>
 * 团队产出奖励记录 A B队抽成
 * </p>
 *
 * @author xudm
 * @since 2024-12-21
 */
@Getter
@Setter
@TableName("b_team_share_reward_record")
public class TeamShareRewardRecord extends Model<TeamShareRewardRecord> {

    /**
     * 主键
     */
    @TableId(value = "id", type = IdType.ASSIGN_ID)
    private Long id;

    /**
     * 奖励领取人id
     */
    @TableField("target_id")
    private Long targetId;

    /**
     * 金币产出人(被邀请人)
     */
    @TableField("invitee_id")
    private Long inviteeId;

    /**
     * 团队类型 【A ，B】
     */
    @TableField("team_type")
    private String teamType;

    /**
     * 奖励金额
     */
    @TableField("reward_amount")
    private BigDecimal rewardAmount;

    /**
     * 产出总额
     */
    @TableField("gold_coin_yield_total")
    private BigDecimal goldCoinYieldTotal;

    /**
     * 产出批次号
     */
    @TableField("batch_id")
    private String batchId;

    /**
     * 抽成比例
     */
    @TableField("scale")
    private String scale;

    /**
     * 领取状态 0 待领取 1 已领取
     */
    @TableField("claim_status")
    private Integer claimStatus;

    /**
     * 领取时间
     */
    @TableField("claim_time")
    private LocalDateTime claimTime;

    /**
     * 生成时间
     */
    @TableField("create_time")
    private LocalDateTime createTime;

    @Override
    public Serializable pkVal() {
        return this.id;
    }
}
