package com.xs.core.model.team.resp;

import io.swagger.v3.oas.annotations.media.Schema;
import lombok.Data;

import java.io.Serializable;
import java.math.BigDecimal;
import java.util.Objects;

@Schema(description = "团队产出用户信息")
@Data
public class TeamShareUserResp implements Serializable {
    /**
     * tg小程序id
     */
    @Schema(description = "tg小程序id")
    private String tgId;

    /**
     * tg账号
     */
    @Schema(description = "tg账号")
    private String tgAccount;

    /**
     * 名
     */
    @Schema(description = "名")
    private String firstName;

    /**
     * 姓
     */
    @Schema(description = "姓")
    private String lastName;

    /**
     * 昵称
     */
    @Schema(description = "昵称")
    private String nickname;

    /**
     * 真实姓名
     */
    @Schema(description = "真实姓名")
    private String realName;

    /**
     * 头像
     */
    @Schema(description = "头像")
    private String avatar;

    /**
     * 团队类型
     */
    @Schema(description = "团队类型")
    private String teamType;

    /**
     * 团队产出奖励金额
     */
    @Schema(description = "团队产出奖励金额")
    private BigDecimal teamRewardAmount;

    /**
     * 被邀请人总产出金额
     */
    @Schema(description = "被邀请人总产出金额")
    private BigDecimal userYieldTotal;

    public String getTgAccount() {
        if (Objects.isNull(tgAccount)) {
            return "";
        }
        //脱敏处理 后几位用*号代替
        if (tgAccount.length() > 3) {
            tgAccount = tgAccount.substring(0, tgAccount.length() - 3) + "***";
        }
        return tgAccount;
    }
}
