package com.xs.core.service.Impl.task;

import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.xs.core.model.task.entity.UserTaskRecord;
import com.xs.core.mapper.task.UserTaskRecordMapper;
import com.xs.core.service.task.IUserTaskRecordService;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import org.springframework.stereotype.Service;

/**
 * <p>
 * 用户任务完成记录表 服务实现类
 * </p>
 *
 * @author xudm
 * @since 2024-12-23
 */
@Service
public class UserTaskRecordServiceImpl extends ServiceImpl<UserTaskRecordMapper, UserTaskRecord> implements IUserTaskRecordService {

    @Override
    public UserTaskRecord getByTaskId(String taskId, Long userId) {
        LambdaQueryWrapper<UserTaskRecord> queryWrapper = new LambdaQueryWrapper<>();
        queryWrapper.eq(UserTaskRecord::getTaskId, taskId);
        queryWrapper.eq(UserTaskRecord::getUserId, userId);
        return getOne(queryWrapper);
    }
}
