package com.xs.core.service.Impl.team;

import cn.hutool.core.util.StrUtil;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.xs.core.model.team.entity.TeamShareRewardRecord;
import com.xs.core.mapper.team.TeamShareRewardRecordMapper;
import com.xs.core.model.team.resp.TeamShareUserResp;
import com.xs.core.model.team.resp.TeamUserResp;
import com.xs.core.service.team.ITeamShareRewardRecordService;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import org.springframework.stereotype.Service;

import java.util.List;

/**
 * <p>
 * 团队产出奖励记录 A B队抽成 服务实现类
 * </p>
 *
 * @author xudm
 * @since 2024-12-21
 */
@Service
public class TeamShareRewardRecordServiceImpl extends ServiceImpl<TeamShareRewardRecordMapper, TeamShareRewardRecord> implements ITeamShareRewardRecordService {

    @Override
    public List<TeamShareUserResp> getTeamShareUserInfoByType(Long userId, String type) {
        return getBaseMapper().getTeamShareUserInfoByType(userId, type);
    }

    @Override
    public List<TeamShareRewardRecord> getNoClaimTeamShareRewardRecordByType(Long userId, String type) {
        LambdaQueryWrapper<TeamShareRewardRecord> queryWrapper = new LambdaQueryWrapper<>();
        queryWrapper.eq(TeamShareRewardRecord::getTargetId, userId);
        queryWrapper.eq(TeamShareRewardRecord::getClaimStatus, 0);
        if (StrUtil.isNotBlank(type)) {
            queryWrapper.eq(TeamShareRewardRecord::getTeamType, type);
        }
        return list(queryWrapper);
    }
}
