package com.xs.core.service.team;

import com.xs.core.model.team.entity.TeamShareRewardRecord;
import com.baomidou.mybatisplus.extension.service.IService;
import com.xs.core.model.team.resp.TeamShareUserResp;
import com.xs.core.model.team.resp.TeamUserResp;

import java.util.List;

/**
 * <p>
 * 团队产出奖励记录 A B队抽成 服务类
 * </p>
 *
 * @author xudm
 * @since 2024-12-21
 */
public interface ITeamShareRewardRecordService extends IService<TeamShareRewardRecord> {

    /**
     * 获取团队产出用户信息 待领取
     *
     * @param userId 用户id
     * @param type   团队类型
     */
    List<TeamShareUserResp> getTeamShareUserInfoByType(Long userId, String type);

    /**
     * 获取未领取的团队产出奖励记录
     *
     * @param userId
     * @param type
     * @return
     */
    List<TeamShareRewardRecord> getNoClaimTeamShareRewardRecordByType(Long userId, String type);

}
